Index: /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd
===================================================================
--- /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd	(revision 234)
+++ /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd	(revision 282)
@@ -16,5 +16,4 @@
 	<xs:simpleType name="computingResourceParameterName">
 		<xs:restriction base="xs:string">
-			<xs:enumeration value="count"/>
 			<xs:enumeration value="arch"/>
 			<xs:enumeration value="memory"/>
@@ -33,5 +32,6 @@
 	</xs:simpleType>
 	
-		<xs:complexType name="logicalResourceParameterType">
+	<!--  
+	<xs:complexType name="logicalResourceParameterType">
 		<xs:annotation>
 			<xs:documentation>Computational resource related parameter</xs:documentation>
@@ -49,4 +49,33 @@
 		</xs:restriction>
 	</xs:simpleType>
+	-->
+		
+	<xs:complexType name="pStateType">
+		<xs:sequence>
+			<xs:element name="name" type="xs:string"></xs:element>
+			<xs:element name="frequency" type="xs:double"></xs:element>
+			<xs:element name="voltage" type="xs:double"></xs:element>
+			<xs:element name="power" type="xs:double"></xs:element>
+		</xs:sequence>
+	</xs:complexType>
+	
+	<xs:complexType name="pStatesType">
+		<xs:choice minOccurs="1" maxOccurs="unbounded">
+			<xs:element name="pState" type="pStateType"></xs:element>
+		</xs:choice>
+	</xs:complexType>
+	
+	<xs:complexType name="powerStatesType">
+		<xs:choice minOccurs="1" maxOccurs="unbounded">
+			<xs:element name="powerState" type="powerStateType"></xs:element>
+		</xs:choice>
+	</xs:complexType>
+	
+	<xs:complexType name="powerStateType">
+		<xs:sequence>
+			<xs:element name="name" type="xs:string"></xs:element>
+			<xs:element name="power" type="xs:double" minOccurs="0" maxOccurs="1"></xs:element>
+		</xs:sequence>
+	</xs:complexType>
 	
 	<xs:complexType name="energyParameterType">
@@ -68,7 +97,43 @@
 	</xs:simpleType>
 	
+	<xs:complexType name="energyEstimationPluginType">
+		<xs:annotation>
+			<xs:documentation>Computational resource related parameter</xs:documentation>
+		</xs:annotation>
+		<xs:sequence>
+			<xs:element name="name" type="xs:string" minOccurs="0" maxOccurs="1"></xs:element>
+			<xs:choice minOccurs="0" maxOccurs="unbounded">
+				<xs:element name="energyParameter" type="energyParameterType"></xs:element>
+			</xs:choice>
+		</xs:sequence>
+	</xs:complexType>
+	
+		<xs:complexType name="energyProfileType">
+		<xs:annotation>
+			<xs:documentation>Computational resource related parameter</xs:documentation>
+		</xs:annotation>
+		<xs:sequence>
+			<xs:element name="name" type="xs:string" minOccurs="0" maxOccurs="1"></xs:element>
+			<xs:choice minOccurs="0" maxOccurs="unbounded">
+				<xs:element name="pStates" type="pStatesType"></xs:element>
+				<xs:element name="powerStates" type="powerStatesType"></xs:element>
+				<xs:element name="energyParameter" type="energyParameterType"></xs:element>
+			</xs:choice>
+		</xs:sequence>
+	</xs:complexType>
+	
+	<xs:complexType name="schedulingPluginType">
+		<xs:annotation>
+			<xs:documentation>Computational resource related parameter</xs:documentation>
+		</xs:annotation>
+		<xs:sequence>
+			<xs:element name="name" type="xs:string" minOccurs="0" maxOccurs="1"></xs:element>
+			<xs:element name="frequency" type="xs:integer" minOccurs="0" maxOccurs="1"></xs:element>
+		</xs:sequence>
+	</xs:complexType>
+	
 	<xs:complexType name="schedulingParameterType">
 		<xs:annotation>
-			<xs:documentation>Computational resource related parameter</xs:documentation>
+			<xs:documentation>Scheduling resource related parameter</xs:documentation>
 		</xs:annotation>
 		<xs:complexContent>
@@ -81,5 +146,5 @@
 	<xs:simpleType name="schedulingParameterName">
 		<xs:restriction base="xs:string">
-			<xs:enumeration value="schedulingPlugin"/>
+			<xs:enumeration value="frequency"/>
 		</xs:restriction>
 	</xs:simpleType>
@@ -126,7 +191,9 @@
 	</xs:complexType>
 	
-	<xs:simpleType name="resourceList">
-		<xs:list itemType="xs:string"></xs:list>
-	</xs:simpleType>
+	<xs:complexType name="resourceList">
+		<xs:choice minOccurs="0" maxOccurs="unbounded">
+			<xs:element name="resourceId" type="xs:string"></xs:element>
+		</xs:choice>
+	</xs:complexType>
 	
 	<xs:complexType name="computingResourceType">
@@ -139,6 +206,6 @@
 					<xs:element name="computingResource" type="computingResourceType"></xs:element>
 					<xs:element name="resourceParameter" type="computingResourceParameterType"></xs:element>
-					<xs:element name="energyParameter" type="energyParameterType"></xs:element>
-					<xs:element name="schedulingParameter" type="schedulingParameterType"></xs:element>
+					<xs:element name="energyEstimationPlugin" type="energyEstimationPluginType"></xs:element>
+					<xs:element name="energyProfile" type="energyProfileType"></xs:element>
 					<xs:element name="otherParameter" type="otherParameterType"/>
 				</xs:choice>
@@ -147,5 +214,5 @@
 	</xs:complexType>
 	
-	<xs:complexType name="logicalResourceType">
+	<xs:complexType name="schedulerType">
 		<xs:annotation>
 			<xs:documentation>Computing resource</xs:documentation>
@@ -154,9 +221,9 @@
 			<xs:extension base="resource">
 			<xs:sequence minOccurs="0" maxOccurs="1">
-				<xs:element name="schedulingParameter" type="schedulingParameterType" minOccurs="0" maxOccurs="1"></xs:element>
+				<xs:element name="schedulingPlugin" type="schedulingPluginType" minOccurs="0" maxOccurs="1"></xs:element>
 				<xs:choice minOccurs="0" maxOccurs="unbounded">
+					<xs:element name="scheduler" type="schedulerType"></xs:element>
 					<xs:element name="managedComputingResource" type="managedComputingResourceType" minOccurs="0" maxOccurs="1"></xs:element>
-					<xs:element name="logicalResource" type="logicalResourceType"></xs:element>
-					<xs:element name="otherParameter" type="otherParameterType"/>
+					<xs:element name="schedulingParameter" type="schedulingParameterType" minOccurs="0" maxOccurs="1"></xs:element>
 				</xs:choice>
 			</xs:sequence>
@@ -168,4 +235,5 @@
 		<xs:attribute name="resourceType" type="xs:string" use="required" />
 		<xs:attribute name="resourceId" type="xs:string" use="optional" />
+		<xs:attribute name="count" type="xs:integer" use="optional" />
 	</xs:complexType>
 
@@ -185,5 +253,5 @@
 							<xs:element name="computingResource" type="computingResourceType" maxOccurs="unbounded">
 							</xs:element>
-							<xs:element name="logicalResource" type="logicalResourceType" minOccurs="0">
+							<xs:element name="scheduler" type="schedulerType" minOccurs="0">
 							</xs:element>
 						</xs:sequence>