Index: /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd
===================================================================
--- /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd	(revision 298)
+++ /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd	(revision 299)
@@ -9,4 +9,5 @@
 		<xs:sequence>
 			<xs:element name="name" type="xs:string"></xs:element>
+			<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 		</xs:sequence>
 	</xs:complexType>
@@ -16,4 +17,7 @@
 			<xs:documentation>Base resource type</xs:documentation>
 		</xs:annotation>
+		<xs:sequence>
+			<xs:element name="description" type="xs:string" minOccurs="0" ></xs:element>
+		</xs:sequence>
 		<xs:attribute name="type" type="xs:string" use="required" />
 		<xs:attribute name="id" type="xs:ID" use="optional" />
@@ -26,37 +30,36 @@
 		<xs:complexContent>
 			<xs:extension base="resourceType">
+				<xs:choice>
+					<xs:sequence>
+						<xs:element name="computingResource" type="computingResourceType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+						<xs:element name="resourceUnit" type="resourceUnitType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+						<xs:element name="otherParameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+						<xs:element name="energyEstimationPlugin" type="energyEstimationPluginType" minOccurs="0" maxOccurs="1"></xs:element>
+						<xs:element name="powerProfile" type="powerProfileType" minOccurs="0" maxOccurs="1"></xs:element>
+						<xs:element name="location" type="locationType" minOccurs="0" maxOccurs="1"></xs:element>
+					</xs:sequence>
+					<xs:sequence>
+						<xs:element name="templateId" type="xs:IDREF"/>
+					</xs:sequence>
+				</xs:choice>
+				<xs:attribute name="groupId" type="xs:integer" use="optional"/>			
+				<xs:attribute name="count" type="xs:integer" use="optional"/>
+			</xs:extension>
+		</xs:complexContent>
+	</xs:complexType>
+	
+	<xs:complexType name="computingResourceTemplateType">
+		<xs:annotation>
+			<xs:documentation>Computing resource instance</xs:documentation>
+		</xs:annotation>
+		<xs:complexContent>
+			<xs:extension base="resourceType">
 				<xs:sequence>
-					<xs:choice minOccurs="0" maxOccurs="unbounded">
-						<xs:element name="computingResource" type="computingResourceType"></xs:element>
-						<xs:element name="resourceUnit" type="resourceUnitType"></xs:element>
-						<xs:element name="otherParameter" type="parameterType"></xs:element>
-					</xs:choice>
+					<xs:element name="computingResource" type="computingResourceType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+					<xs:element name="resourceUnit" type="resourceUnitType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+					<xs:element name="otherParameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 					<xs:element name="energyEstimationPlugin" type="energyEstimationPluginType" minOccurs="0" maxOccurs="1"></xs:element>
-					<xs:element name="energyPowerProfile" type="energyPowerProfileType" minOccurs="0" maxOccurs="1"></xs:element>
-					<xs:element name="location" type="locationType" minOccurs="0" maxOccurs="1"></xs:element>
+					<xs:element name="powerProfile" type="powerProfileType" minOccurs="0" maxOccurs="1"></xs:element>
 				</xs:sequence>
-				<xs:attribute name="groupId" type="xs:integer" use="optional"/>
-				<xs:attribute name="templateId" type="xs:IDREF" use="optional"/>				
-				<xs:attribute name="count" type="xs:integer" use="optional"/>
-			</xs:extension>
-		</xs:complexContent>
-	</xs:complexType>
-	
-	<xs:complexType name="computingResourceTemplateType">
-		<xs:annotation>
-			<xs:documentation>Computing resource instance</xs:documentation>
-		</xs:annotation>
-		<xs:complexContent>
-			<xs:extension base="resourceType">
-				<xs:sequence>
-					<xs:choice minOccurs="0" maxOccurs="unbounded">
-						<xs:element name="computingResource" type="computingResourceTemplateType"></xs:element>
-						<xs:element name="resourceUnit" type="resourceUnitType"></xs:element>
-						<xs:element name="otherParameter" type="parameterType"></xs:element>
-					</xs:choice>
-					<xs:element name="energyEstimationPlugin" type="energyEstimationPluginType" minOccurs="0" maxOccurs="1"></xs:element>
-					<xs:element name="energyPowerProfile" type="energyPowerProfileType" minOccurs="0" maxOccurs="1"></xs:element>
-				</xs:sequence>
-				<xs:attribute name="count" type="xs:integer" use="optional"/>
 				<xs:attribute name="templateId" type="xs:IDREF" use="optional"/>
 			</xs:extension>
@@ -72,9 +75,9 @@
 				<xs:sequence>
 					<xs:element name="schedulingPlugin" type="schedulingPluginType" minOccurs="0" maxOccurs="1"></xs:element>
-					<xs:choice minOccurs="0" maxOccurs="unbounded">
+					<xs:choice minOccurs="1" maxOccurs="unbounded">
 						<xs:element name="scheduler" type="schedulerType"></xs:element>
 						<xs:element name="managedComputingResource" type="managedComputingResourceType"></xs:element>
-						<xs:element name="parameter" type="parameterType"></xs:element>
 					</xs:choice>
+					<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 				</xs:sequence>
 			</xs:extension>
@@ -99,5 +102,5 @@
 			<xs:extension base="resourceType">
 				<xs:sequence>
-					<xs:element name="amount" type="xs:string"/>
+					<xs:element name="amount" type="xs:integer"/>
 				</xs:sequence>
 			</xs:extension>
@@ -134,15 +137,15 @@
 	</xs:complexType>
 	
-	<xs:complexType name="energyPowerProfileType">
-		<xs:annotation>
-			<xs:documentation>Energy power profile</xs:documentation>
+	<xs:complexType name="powerProfileType">
+		<xs:annotation>
+			<xs:documentation>power profile</xs:documentation>
 		</xs:annotation>
 		<xs:sequence>
 			<xs:element name="name" type="xs:string" minOccurs="0" maxOccurs="1"></xs:element>
-			<xs:choice minOccurs="0" maxOccurs="unbounded">
-				<xs:element name="powerStates" type="powerStatesType"></xs:element>
-				<xs:element name="pStates" type="pStatesType"></xs:element>
-				<xs:element name="parameter" type="parameterType"></xs:element>
-			</xs:choice>
+			<xs:sequence>
+				<xs:element name="powerStates" type="powerStatesType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+				<xs:element name="pStates" type="pStatesType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+				<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
+			</xs:sequence>
 		</xs:sequence>
 	</xs:complexType>
@@ -185,5 +188,5 @@
 			<xs:element name="name" type="xs:string"></xs:element>
 			<xs:element name="power" type="xs:double" minOccurs="0" maxOccurs="1"></xs:element>
-			<xs:element name="transition" type="energyStatesTransitionType" minOccurs="0" maxOccurs="1"></xs:element>
+			<xs:element name="transition" type="energyStatesTransitionType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 		</xs:sequence>
 	</xs:complexType>
@@ -211,32 +214,12 @@
 	</xs:complexType>
 	
-	<xs:complexType name="baseParameterType">
+	<xs:complexType name="parameterType">
 		<xs:annotation>
 			<xs:documentation>Base description of parameter of resource</xs:documentation>
 		</xs:annotation>
 		<xs:sequence>
-			<xs:element name="paramValue" type="xs:string"/>
+			<xs:element name="paramValue" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
 		</xs:sequence>
 		<xs:attribute name="name" type="xs:string" use="required"/>
-	</xs:complexType>
-	
-	<xs:complexType name="parameterType">
-		<xs:annotation>
-			<xs:documentation>Description of parameter of resource</xs:documentation>
-		</xs:annotation>
-		<xs:complexContent>
-			<xs:extension base="baseParameterType">
-				<xs:sequence>
-					<xs:element name="property" minOccurs="0" maxOccurs="unbounded">
-						<xs:complexType>
-							<xs:sequence>
-								<xs:element name="value" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
-							</xs:sequence>
-							<xs:attribute name="name" type="xs:string" use="required"/>
-						</xs:complexType>
-					</xs:element>
-				</xs:sequence>
-			</xs:extension>
-		</xs:complexContent>
 	</xs:complexType>
 	
@@ -247,4 +230,5 @@
 		<xs:complexType>
 			<xs:sequence>
+				<xs:element name="description" type="xs:string" minOccurs="0" ></xs:element>
 				<xs:element name="timeEstimationPlugin" type="timeEstimationPluginType" minOccurs="0" maxOccurs="1">
 					<xs:annotation>