Index: /xssim/trunk/src/test/rewolucja/schemas/example/example7.xml
===================================================================
--- /xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 309)
+++ /xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 309)
@@ -0,0 +1,154 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<environment xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" 
+	xsi:noNamespaceSchemaLocation="../XSSimResSchema.xsd">
+	
+	<timeEstimationPlugin>
+		<name>ExecTimeEstimationPlugin</name>
+	</timeEstimationPlugin>
+	
+	<!-- Opis dla data center z uwzglednieniem szablonow i przejsc miedzy stanami energetycznymi -->
+	<resources>
+		<computingResource type="DataCenter" id="compRes1">
+			<computingResource type="Rack" id="rack1">
+				<computingResource type="ComputingNode" id="node11">
+				</computingResource>
+				<computingResource type="ComputingNode" id="node12">
+				</computingResource>
+			</computingResource>	
+			<computingResource type="Rack" id="rack2">
+				<computingResource type="ComputingNode" id="node21">
+					<templateId>modelNodeA</templateId>
+				</computingResource>
+				<computingResource type="ComputingNode" id="node22">
+					<computingResource type="Processor" count="8">
+						<templateId>modelProcessorB</templateId>
+					</computingResource>
+				</computingResource>
+			</computingResource>
+		</computingResource>	
+		<scheduler type="Cluster" id="cluster1">
+			<schedulingPlugin>
+				<name>FCFSLocalSchedulingPlugin</name>
+			</schedulingPlugin>		
+			<managedComputingResource>
+				<associatedComputingResource>compRes1</associatedComputingResource>
+			</managedComputingResource>
+		</scheduler>
+	</resources>
+	
+	<templates>
+		<computingResourceTemplate type="ComputingNode" id="modelNodeA">
+			<computingResource type="Processor" count="4">
+				<templateId>modelProcessorA</templateId>
+			</computingResource>
+		</computingResourceTemplate>	
+		<computingResourceTemplate type="Processor" id="modelProcessorA">
+			<energyEstimationPlugin>
+				<name>CPUEnergyEstimationPlugin</name>
+			</energyEstimationPlugin>
+			<powerProfile>
+				<name>CPUPowerProfile</name>
+				<powerStates>
+					<powerState>
+						<name>ON</name>
+						<power>20</power>
+						<transition>
+							<to>OFF</to>
+							<power>30</power>
+							<time>30</time>
+						</transition>
+					</powerState>
+					<powerState>
+						<name>OFF</name>
+						<power>0</power>
+						<transition>
+							<to>ON</to>
+							<power>40</power>
+							<time>60</time>
+						</transition>
+					</powerState>
+				</powerStates>
+				<pStates>
+					<pState>
+						<name>P0</name>
+						<frequency>3000</frequency>
+						<voltage>1.3</voltage>
+						<power>14</power>
+					</pState>
+					<pState>
+						<name>P1</name>
+						<frequency>2660</frequency>
+						<voltage>1.2</voltage>
+						<power>12</power>
+					</pState>
+					<pState>
+						<name>P2</name>
+						<frequency>2330</frequency>
+						<voltage>1.1</voltage>
+						<power>10</power>
+					</pState>
+					<pState>
+						<name>P3</name>
+						<frequency>2000</frequency>
+						<voltage>1.0</voltage>
+						<power>8</power>
+					</pState>
+				</pStates>
+			</powerProfile>
+		</computingResourceTemplate>
+		<computingResourceTemplate type="Processor" id="modelProcessorB">
+			<energyEstimationPlugin>
+				<name>CPUEnergyEstimationPlugin</name>
+			</energyEstimationPlugin>
+			<powerProfile>
+				<name>CPUPowerProfile</name>
+				<powerStates>
+					<powerState>
+						<name>ON</name>
+						<power>20</power>
+						<transition>
+							<to>OFF</to>
+							<power>30</power>
+							<time>30</time>
+						</transition>
+					</powerState>
+					<powerState>
+						<name>OFF</name>
+						<power>0</power>
+						<transition>
+							<to>ON</to>
+							<power>40</power>
+							<time>60</time>
+						</transition>
+					</powerState>
+				</powerStates>
+				<pStates>
+					<pState>
+						<name>P0</name>
+						<frequency>2200</frequency>
+						<voltage>1.3</voltage>
+						<power>20</power>
+					</pState>
+					<pState>
+						<name>P1</name>
+						<frequency>2000</frequency>
+						<voltage>1.2</voltage>
+						<power>17</power>
+					</pState>
+					<pState>
+						<name>P2</name>
+						<frequency>1800</frequency>
+						<voltage>1.1</voltage>
+						<power>16</power>
+					</pState>
+					<pState>
+						<name>P3</name>
+						<frequency>1000</frequency>
+						<voltage>1.0</voltage>
+						<power>10</power>
+					</pState>
+				</pStates>
+			</powerProfile>
+		</computingResourceTemplate>
+	</templates>
+</environment>