Index: xssim/trunk/src/test/rewolucja/schemas/example/example3.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example3.xml	(revision 294)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example3.xml	(revision 311)
@@ -30,10 +30,8 @@
 					<name>FCFSLocalSchedulingPlugin</name>
 				</schedulingPlugin>	
-				<managedComputingResource>
-					<listOfManagedResources>
-						<resourceId>node11</resourceId>
-						<resourceId>node12</resourceId>
-						<resourceId>node13</resourceId>
-					</listOfManagedResources>
+				<managedComputingResource include="true">
+					<resourceId>node11</resourceId>
+					<resourceId>node12</resourceId>
+					<resourceId>node13</resourceId>
 				</managedComputingResource>
 			</scheduler>
@@ -42,10 +40,8 @@
 					<name>FCFSLocalSchedulingPlugin</name>
 				</schedulingPlugin>
-				<managedComputingResource>
-					<listOfManagedResources>
-						<resourceId>node14</resourceId>
-						<resourceId>node15</resourceId>
-						<resourceId>node16</resourceId>
-					</listOfManagedResources>
+				<managedComputingResource include="true">
+					<resourceId>node14</resourceId>
+					<resourceId>node15</resourceId>
+					<resourceId>node16</resourceId>
 				</managedComputingResource>
 			</scheduler>
@@ -54,10 +50,8 @@
 					<name>FCFSLocalSchedulingPlugin</name>
 				</schedulingPlugin>
-				<managedComputingResource>
-					<listOfManagedResources>
-						<resourceId>node21</resourceId>
-						<resourceId>node22</resourceId>
-						<resourceId>node23</resourceId>
-					</listOfManagedResources>
+				<managedComputingResource include="true">
+					<resourceId>node21</resourceId>
+					<resourceId>node22</resourceId>
+					<resourceId>node23</resourceId>
 				</managedComputingResource>
 			</scheduler>
@@ -66,10 +60,8 @@
 					<name>FCFSLocalSchedulingPlugin</name>
 				</schedulingPlugin>
-				<managedComputingResource>
-					<listOfManagedResources>
-						<resourceId>node24</resourceId>
-						<resourceId>node25</resourceId>
-						<resourceId>node26</resourceId>
-					</listOfManagedResources>
+				<managedComputingResource include="true">
+					<resourceId>node24</resourceId>
+					<resourceId>node25</resourceId>
+					<resourceId>node26</resourceId>
 				</managedComputingResource>
 			</scheduler>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example4.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example4.xml	(revision 307)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example4.xml	(revision 311)
@@ -29,7 +29,7 @@
 				<name>FCFSLocalSchedulingPlugin</name>
 			</schedulingPlugin>		
-			<managedComputingResource>
-				<associatedComputingResource>compRes1</associatedComputingResource>
-			</managedComputingResource>
+				<managedComputingResource include="false">
+					<resourceId>compRes1</resourceId>
+				</managedComputingResource>
 		</scheduler>	
 	</resources>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example5.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example5.xml	(revision 308)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example5.xml	(revision 311)
@@ -51,7 +51,7 @@
 				<name>FCFSLocalSchedulingPlugin</name>
 			</schedulingPlugin>		
-			<managedComputingResource>
-				<associatedComputingResource>compRes1</associatedComputingResource>
-			</managedComputingResource>
+				<managedComputingResource include="false">
+					<resourceId>compRes1</resourceId>
+				</managedComputingResource>
 		</scheduler>	
 	</resources>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example6.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example6.xml	(revision 297)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example6.xml	(revision 311)
@@ -33,6 +33,6 @@
 				<name>FCFSLocalSchedulingPlugin</name>
 			</schedulingPlugin>		
-			<managedComputingResource>
-				<associatedComputingResource>compRes1</associatedComputingResource>
+			<managedComputingResource include="false">
+				<resourceId>compRes1</resourceId>
 			</managedComputingResource>
 		</scheduler>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example7.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 309)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 311)
@@ -31,6 +31,6 @@
 				<name>FCFSLocalSchedulingPlugin</name>
 			</schedulingPlugin>		
-			<managedComputingResource>
-				<associatedComputingResource>compRes1</associatedComputingResource>
+			<managedComputingResource include="false">
+				<resourceId>compRes1</resourceId>
 			</managedComputingResource>
 		</scheduler>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example1.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example1.xml	(revision 297)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example1.xml	(revision 311)
@@ -20,6 +20,6 @@
 					<name>FCFSLocalSchedulingPlugin</name>
 				</schedulingPlugin>	
-				<managedComputingResource>
-					<associatedComputingResource>compRes1</associatedComputingResource>
+				<managedComputingResource include="false">
+					<resourceId>compRes1</resourceId>
 				</managedComputingResource>
 			</scheduler>
@@ -28,7 +28,7 @@
 					<name>FCFSLocalSchedulingPlugin</name>
 				</schedulingPlugin>	
-				<managedComputingResource>
-					<associatedComputingResource>compRes2</associatedComputingResource>
-				</managedComputingResource>	
+				<managedComputingResource include="false">
+					<resourceId>compRes2</resourceId>
+				</managedComputingResource>
 			</scheduler>
 		</scheduler>	
Index: xssim/trunk/src/test/rewolucja/schemas/example/example2.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example2.xml	(revision 294)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example2.xml	(revision 311)
@@ -22,6 +22,6 @@
 					<frequency>600</frequency>
 				</schedulingPlugin>		
-				<managedComputingResource>
-					<associatedComputingResource>compRes1</associatedComputingResource>
+				<managedComputingResource include="false">
+					<resourceId>compRes1</resourceId>
 				</managedComputingResource>
 			</scheduler>
@@ -31,7 +31,7 @@
 					<frequency>600</frequency>
 				</schedulingPlugin>	
-				<managedComputingResource>
-					<associatedComputingResource>compRes2</associatedComputingResource>
-				</managedComputingResource>	
+				<managedComputingResource include="false">
+					<resourceId>compRes2</resourceId>
+				</managedComputingResource>
 			</scheduler>
 		</scheduler>	