Index: xssim/trunk/src/test/rewolucja/schemas/example/example1.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example1.xml	(revision 311)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example1.xml	(revision 316)
@@ -4,17 +4,17 @@
 	<!-- Analogiczny opis zasobow jak do tej pory, dla srodowiska gridowego -->
 	<resources>
-		<computingResource type="DataCenter" id="compRes1">
-			<computingResource type="Processor" count="64"/>
+		<computingResource class="DataCenter" id="compRes1">
+			<computingResource class="Processor" count="64"/>
 		</computingResource>	
-		<computingResource type="DataCenter" id="compRes2">
-			<computingResource type="Processor" count="64"/>
+		<computingResource class="DataCenter" id="compRes2">
+			<computingResource class="Processor" count="64"/>
 		</computingResource>
 		<!-- Plugin dla Brokera
 		Definicja pluginu zostala przeniesiona z pliku z propertiesami ma byc tu czy w propertiesach, sciezki bezwzledne czy wzgledne z domyslnej lokalizacji (moga byc obie mozliwosci ale to juz na poziomie tworzenia zasobow)-->
-		<scheduler type="GridBroker" id="gridBroker">
+		<scheduler class="GridBroker" id="gridBroker">
 			<schedulingPlugin>
 				<name>GridFCFSLoadBalancingPlugin</name>
 			</schedulingPlugin>
-			<scheduler type="Cluster" id="cluster1">
+			<scheduler class="Cluster" id="cluster1">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
@@ -24,5 +24,5 @@
 				</managedComputingResource>
 			</scheduler>
-			<scheduler type="Cluster" id="cluster2">
+			<scheduler class="Cluster" id="cluster2">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example2.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example2.xml	(revision 311)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example2.xml	(revision 316)
@@ -4,18 +4,18 @@
 	<!-- Opis zasobow dla srodowiska gridowego -->
 	<resources>
-		<computingResource type="DataCenter" id="compRes1">
-			<computingResource type="Processor" count="64"/>
+		<computingResource class="DataCenter" id="compRes1">
+			<computingResource class="Processor" count="64"/>
 		</computingResource>	
-		<computingResource type="DataCenter" id="compRes2">
-			<computingResource type="Processor" count="64"/>
+		<computingResource class="DataCenter" id="compRes2">
+			<computingResource class="Processor" count="64"/>
 		</computingResource>
 		<!-- W tym przypadku Broker zarzadza dwoma klastrami (cluster1 i cluster2)
 		Kazdy z klastrow skojarzony jest z odpowiednimi zasobami (odpowiednio compRes1 i compRes2) tzn. sklada sie(zarzadza) wszystkimi zasobami znajdujacymi sie pod nimi
 		Patrz tez example3.xml -->
-		<scheduler type="GridBroker" id="gridBroker">
+		<scheduler class="GridBroker" id="gridBroker">
 			<schedulingPlugin>
 				<name>GridFCFSLoadBalancingPlugin</name>
 			</schedulingPlugin>
-			<scheduler type="Cluster" id="cluster1">
+			<scheduler class="Cluster" id="cluster1">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
@@ -26,5 +26,5 @@
 				</managedComputingResource>
 			</scheduler>
-			<scheduler type="Cluster" id="cluster2">
+			<scheduler class="Cluster" id="cluster2">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example3.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example3.xml	(revision 311)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example3.xml	(revision 316)
@@ -4,27 +4,27 @@
 	<!-- Opis zasobow dla srodowiska gridowego -->
 	<resources>
-		<computingResource type="DataCenter" id="compRes1">
-			<computingResource type="ComputingNode" id="node11"/>
-			<computingResource type="ComputingNode" id="node12"/>
-			<computingResource type="ComputingNode" id="node13"/>
-			<computingResource type="ComputingNode" id="node14"/>
-			<computingResource type="ComputingNode" id="node15"/>
-			<computingResource type="ComputingNode" id="node16"/>
+		<computingResource class="DataCenter" id="compRes1">
+			<computingResource class="ComputingNode" id="node11"/>
+			<computingResource class="ComputingNode" id="node12"/>
+			<computingResource class="ComputingNode" id="node13"/>
+			<computingResource class="ComputingNode" id="node14"/>
+			<computingResource class="ComputingNode" id="node15"/>
+			<computingResource class="ComputingNode" id="node16"/>
 		</computingResource>	
-		<computingResource type="DataCenter" id="compRes2">
-			<computingResource type="ComputingNode" id="node21"/>
-			<computingResource type="ComputingNode" id="node22"/>
-			<computingResource type="ComputingNode" id="node23"/>
-			<computingResource type="ComputingNode" id="node24"/>
-			<computingResource type="ComputingNode" id="node25"/>
-			<computingResource type="ComputingNode" id="node26"/>
+		<computingResource class="DataCenter" id="compRes2">
+			<computingResource class="ComputingNode" id="node21"/>
+			<computingResource class="ComputingNode" id="node22"/>
+			<computingResource class="ComputingNode" id="node23"/>
+			<computingResource class="ComputingNode" id="node24"/>
+			<computingResource class="ComputingNode" id="node25"/>
+			<computingResource class="ComputingNode" id="node26"/>
 		</computingResource>
 		<!-- W tym przypadku Broker zarzadza czterema klastrami (cluter1, cluster2, cluster3, cluster4)
 		Kazdy z klastrow sklada sie(zarzadza) z 3 wezlow wylistowanych ponizej -->
-		<scheduler type="GridBroker" id="gridBroker">
+		<scheduler class="GridBroker" id="gridBroker">
 			<schedulingPlugin>
 				<name>GridFCFSLoadBalancingPlugin</name>
 			</schedulingPlugin>
-			<scheduler type="Cluster" id="cluster1">
+			<scheduler class="Cluster" id="cluster1">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
@@ -36,5 +36,5 @@
 				</managedComputingResource>
 			</scheduler>
-			<scheduler type="Cluster" id="cluster2">
+			<scheduler class="Cluster" id="cluster2">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
@@ -46,5 +46,5 @@
 				</managedComputingResource>
 			</scheduler>
-			<scheduler type="Cluster" id="cluster3">
+			<scheduler class="Cluster" id="cluster3">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
@@ -56,5 +56,5 @@
 				</managedComputingResource>
 			</scheduler>
-			<scheduler type="Cluster" id="cluster4">
+			<scheduler class="Cluster" id="cluster4">
 				<schedulingPlugin>
 					<name>FCFSLocalSchedulingPlugin</name>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example4.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example4.xml	(revision 311)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example4.xml	(revision 316)
@@ -5,25 +5,25 @@
 	<!-- Opis dla data center z podstawowa charakterystyka zasobow -->
 	<resources>
-		<computingResource type="DataCenter" id="compRes1">
-			<computingResource type="ComputingNode" id="compNode1">
-				<computingResource type="Processor" count="8"/>
-				<resourceUnit type="memory">
+		<computingResource class="DataCenter" id="compRes1">
+			<computingResource class="ComputingNode" id="compNode1">
+				<computingResource class="Processor" count="8"/>
+				<resourceUnit class="memory">
 					<amount>12288</amount>
 				</resourceUnit>
-				<resourceUnit type="cost">
+				<resourceUnit class="cost">
 					<amount>100</amount>
 				</resourceUnit>
 			</computingResource>	
-			<computingResource type="ComputingNode" id="compNode2">
-				<computingResource type="Processor" count="8"/>
-				<resourceUnit type="memory">
+			<computingResource class="ComputingNode" id="compNode2">
+				<computingResource class="Processor" count="8"/>
+				<resourceUnit class="memory">
 					<amount>12288</amount>
 				</resourceUnit>
-				<resourceUnit type="cost">
+				<resourceUnit class="cost">
 					<amount>60</amount>
 				</resourceUnit>
 			</computingResource>
 		</computingResource>
-		<scheduler type="Cluster" id="cluster1">
+		<scheduler class="Cluster" id="cluster1">
 			<schedulingPlugin>
 				<name>FCFSLocalSchedulingPlugin</name>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example5.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example5.xml	(revision 311)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example5.xml	(revision 316)
@@ -5,12 +5,11 @@
 	<!-- Opis dla data center z uwzglednieniem aspektow energetycznych -->
 	<resources>
-		<computingResource type="DataCenter" id="compRes1">
-			<computingResource type="ComputingNode" count="57">
-				<computingResource type="Processor" count="8">
+		<computingResource class="DataCenter" id="compRes1">
+			<computingResource class="ComputingNode" count="57">
+				<computingResource class="Processor" count="8">
 					<energyEstimationPlugin>
 						<name>CPUEnergyEstimationPlugin</name>
 					</energyEstimationPlugin>
 					<powerProfile>
-						<name>CPUPowerProfile</name>
 						<powerStates>
 							<powerState>
@@ -42,10 +41,7 @@
 					<name>ComputingNodeEnergyEstimationPlugin</name>
 				</energyEstimationPlugin>
-				<powerProfile>
-					<name>ComputingNodePowerProfile</name>
-				</powerProfile>
 			</computingResource>	
 		</computingResource>
-		<scheduler type="Cluster" id="cluster1">
+		<scheduler class="Cluster" id="cluster1">
 			<schedulingPlugin>
 				<name>FCFSLocalSchedulingPlugin</name>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example6.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example6.xml	(revision 311)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example6.xml	(revision 316)
@@ -5,15 +5,15 @@
 	<!-- Opis dla data center z uwzglednieniem rozmieszczenia zasobow -->
 	<resources>
-		<computingResource type="DataCenter" id="compRes1">
-			<computingResource type="Rack" id="rack1">
-				<computingResource type="ComputingNode" id="node11">
+		<computingResource class="DataCenter" id="compRes1">
+			<computingResource class="Rack" id="rack1">
+				<computingResource class="ComputingNode" id="node11">
 				</computingResource>
-				<computingResource type="ComputingNode" id="node12">
+				<computingResource class="ComputingNode" id="node12">
 				</computingResource>
 			</computingResource>	
-			<computingResource type="Rack" id="rack2">
-				<computingResource type="ComputingNode" id="node21">
+			<computingResource class="Rack" id="rack2">
+				<computingResource class="ComputingNode" id="node21">
 				</computingResource>
-				<computingResource type="ComputingNode" id="node22">
+				<computingResource class="ComputingNode" id="node22">
 				</computingResource>
 				<location>
@@ -29,5 +29,5 @@
 			</location>
 		</computingResource>	
-		<scheduler type="Cluster" id="cluster1">
+		<scheduler class="Cluster" id="cluster1">
 			<schedulingPlugin>
 				<name>FCFSLocalSchedulingPlugin</name>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example7.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 311)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 316)
@@ -9,17 +9,17 @@
 	<!-- Opis dla data center z uwzglednieniem szablonow i przejsc miedzy stanami energetycznymi -->
 	<resources>
-		<computingResource type="DataCenter" id="compRes1">
-			<computingResource type="Rack" id="rack1">
-				<computingResource type="ComputingNode" id="node11">
+		<computingResource class="DataCenter" id="compRes1">
+			<computingResource class="Rack" id="rack1">
+				<computingResource class="ComputingNode" id="node11">
 				</computingResource>
-				<computingResource type="ComputingNode" id="node12">
+				<computingResource class="ComputingNode" id="node12">
 				</computingResource>
 			</computingResource>	
-			<computingResource type="Rack" id="rack2">
-				<computingResource type="ComputingNode" id="node21">
+			<computingResource class="Rack" id="rack2">
+				<computingResource class="ComputingNode" id="node21">
 					<templateId>modelNodeA</templateId>
 				</computingResource>
-				<computingResource type="ComputingNode" id="node22">
-					<computingResource type="Processor" count="8">
+				<computingResource class="ComputingNode" id="node22">
+					<computingResource class="Processor" count="8">
 						<templateId>modelProcessorB</templateId>
 					</computingResource>
@@ -27,5 +27,5 @@
 			</computingResource>
 		</computingResource>	
-		<scheduler type="Cluster" id="cluster1">
+		<scheduler class="Cluster" id="cluster1">
 			<schedulingPlugin>
 				<name>FCFSLocalSchedulingPlugin</name>
@@ -38,15 +38,14 @@
 	
 	<templates>
-		<computingResourceTemplate type="ComputingNode" id="modelNodeA">
-			<computingResource type="Processor" count="4">
+		<computingResourceTemplate class="ComputingNode" id="modelNodeA">
+			<computingResource class="Processor" count="4">
 				<templateId>modelProcessorA</templateId>
 			</computingResource>
 		</computingResourceTemplate>	
-		<computingResourceTemplate type="Processor" id="modelProcessorA">
+		<computingResourceTemplate class="Processor" id="modelProcessorA">
 			<energyEstimationPlugin>
 				<name>CPUEnergyEstimationPlugin</name>
 			</energyEstimationPlugin>
 			<powerProfile>
-				<name>CPUPowerProfile</name>
 				<powerStates>
 					<powerState>
@@ -97,10 +96,9 @@
 			</powerProfile>
 		</computingResourceTemplate>
-		<computingResourceTemplate type="Processor" id="modelProcessorB">
+		<computingResourceTemplate class="Processor" id="modelProcessorB">
 			<energyEstimationPlugin>
 				<name>CPUEnergyEstimationPlugin</name>
 			</energyEstimationPlugin>
 			<powerProfile>
-				<name>CPUPowerProfile</name>
 				<powerStates>
 					<powerState>