Index: /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd
===================================================================
--- /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd	(revision 315)
+++ /xssim/trunk/src/test/rewolucja/schemas/XSSimResSchema.xsd	(revision 317)
@@ -47,5 +47,5 @@
 							<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 							<xs:element name="energyEstimationPlugin" type="energyEstimationPluginType" minOccurs="0" maxOccurs="1"></xs:element>
-							<xs:element name="powerProfile" type="powerProfileType" minOccurs="0" maxOccurs="1"></xs:element>
+							<xs:element name="profile" type="profileType" minOccurs="0" maxOccurs="1"></xs:element>
 						</xs:sequence>
 						<xs:element name="templateId" type="xs:IDREF"/>
@@ -70,5 +70,5 @@
 					<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 					<xs:element name="energyEstimationPlugin" type="energyEstimationPluginType" minOccurs="0" maxOccurs="1"></xs:element>
-					<xs:element name="powerProfile" type="powerProfileType" minOccurs="0" maxOccurs="1"></xs:element>
+					<xs:element name="profile" type="profileType" minOccurs="0" maxOccurs="1"></xs:element>
 				</xs:sequence>
 			</xs:extension>
@@ -115,4 +115,5 @@
 				<xs:sequence>
 					<xs:element name="amount" type="xs:double"/>
+					<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 				</xs:sequence>
 			</xs:extension>
@@ -139,36 +140,21 @@
 	</xs:complexType>
 	
+	<xs:complexType name="profileType">
+		<xs:annotation>
+			<xs:documentation>Resource profiles</xs:documentation>
+		</xs:annotation>
+		<xs:sequence>
+			<xs:element name="powerProfile" type="powerProfileType" minOccurs="0"></xs:element>
+			<xs:element name="airThroughputProfile" type="airThroughputProfileType" minOccurs="0"></xs:element>
+		</xs:sequence>
+	</xs:complexType>
+	
 	<xs:complexType name="powerProfileType">
 		<xs:annotation>
-			<xs:documentation>power profile</xs:documentation>
-		</xs:annotation>
-		<xs:sequence>
-			<xs:sequence>
-				<xs:element name="powerStates" type="powerStatesType" minOccurs="0"></xs:element>
-				<xs:element name="pStates" type="pStatesType" minOccurs="0"></xs:element>
-				<xs:element name="fan" type="fanType" minOccurs="0"></xs:element>
-				<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
-			</xs:sequence>
-		</xs:sequence>
-	</xs:complexType>
-
-	<xs:complexType name="pStatesType">
-		<xs:annotation>
-			<xs:documentation>Definition of supported  p-states</xs:documentation>
-		</xs:annotation>
-		<xs:sequence minOccurs="1" maxOccurs="unbounded">
-			<xs:element name="pState" type="pStateType"></xs:element>
-		</xs:sequence>
-	</xs:complexType>
-	
-	<xs:complexType name="pStateType">
-		<xs:annotation>
-			<xs:documentation>Definition of the p-state</xs:documentation>
-		</xs:annotation>
-		<xs:sequence>
-			<xs:element name="name" type="xs:string"></xs:element>
-			<xs:element name="frequency" type="xs:double"></xs:element>
-			<xs:element name="voltage" type="xs:double" minOccurs="0"></xs:element>
-			<xs:element name="power" type="xs:double"></xs:element>
+			<xs:documentation>Power profile</xs:documentation>
+		</xs:annotation>
+		<xs:sequence>
+			<xs:element name="powerStates" type="powerStatesType" minOccurs="0"></xs:element>
+			<xs:element name="parameter" type="parameterType" minOccurs="0" maxOccurs="unbounded"></xs:element>
 		</xs:sequence>
 	</xs:complexType>
@@ -205,21 +191,21 @@
 	</xs:complexType>
 	
-	<xs:complexType name="fanType">
+	<xs:complexType name="airThroughputProfileType">
 		<xs:annotation>
 			<xs:documentation>Description of the computing resource fan</xs:documentation>
 		</xs:annotation>
 		<xs:sequence minOccurs="1" maxOccurs="unbounded">
-			<xs:element name="fanState" type="fanStateType"></xs:element>
-		</xs:sequence>
-	</xs:complexType>
-	
-	<xs:complexType name="fanStateType">
+			<xs:element name="airThroughput" type="airThroughputType"></xs:element>
+		</xs:sequence>
+	</xs:complexType>
+	
+	<xs:complexType name="airThroughputType">
 		<xs:annotation>
 			<xs:documentation>Definition of the power state</xs:documentation>
 		</xs:annotation>
 		<xs:sequence>
-			<xs:element name="speed" type="xs:double"></xs:element>
-			<xs:element name="airThroughput" type="xs:double"></xs:element>
-			<xs:element name="power" type="xs:double" minOccurs="0"></xs:element>
+			<xs:element name="name" type="xs:string"></xs:element>
+			<xs:element name="value" type="xs:double"></xs:element>
+			<xs:element name="powerConsumption" type="xs:double" minOccurs="0"></xs:element>
 		</xs:sequence>
 	</xs:complexType>
@@ -240,7 +226,17 @@
 			<xs:documentation>Description of parameter of resource</xs:documentation>
 		</xs:annotation>
-		<xs:sequence>
+		<xs:choice>
 			<xs:element name="value" type="xs:string" minOccurs="0" maxOccurs="unbounded"/>
-		</xs:sequence>
+			<xs:sequence minOccurs="0" maxOccurs="unbounded">
+				<xs:element name="property">
+				<xs:complexType>
+					<xs:sequence>
+						<xs:element name="value" type="xs:string"/>
+					</xs:sequence>
+					<xs:attribute name="name" type="xs:string" use="required"/>
+				</xs:complexType>
+			</xs:element>
+			</xs:sequence>
+		</xs:choice>
 		<xs:attribute name="name" type="xs:string" use="required"/>
 	</xs:complexType>