Index: xssim/trunk/src/test/rewolucja/schemas/example/example7.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 316)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example7.xml	(revision 318)
@@ -47,52 +47,84 @@
 				<name>CPUEnergyEstimationPlugin</name>
 			</energyEstimationPlugin>
-			<powerProfile>
-				<powerStates>
-					<powerState>
-						<name>ON</name>
-						<power>20</power>
-						<transition>
-							<to>OFF</to>
-							<power>30</power>
-							<time>30</time>
-						</transition>
-					</powerState>
-					<powerState>
-						<name>OFF</name>
-						<power>0</power>
-						<transition>
-							<to>ON</to>
-							<power>40</power>
-							<time>60</time>
-						</transition>
-					</powerState>
-				</powerStates>
-				<pStates>
-					<pState>
-						<name>P0</name>
-						<frequency>3000</frequency>
-						<voltage>1.3</voltage>
-						<power>14</power>
-					</pState>
-					<pState>
-						<name>P1</name>
-						<frequency>2660</frequency>
-						<voltage>1.2</voltage>
-						<power>12</power>
-					</pState>
-					<pState>
-						<name>P2</name>
-						<frequency>2330</frequency>
-						<voltage>1.1</voltage>
-						<power>10</power>
-					</pState>
-					<pState>
-						<name>P3</name>
-						<frequency>2000</frequency>
-						<voltage>1.0</voltage>
-						<power>8</power>
-					</pState>
-				</pStates>
-			</powerProfile>
+			<profile>
+				<powerProfile>
+					<powerStates>
+						<powerState>
+							<name>ON</name>
+							<power>20</power>
+							<transition>
+								<to>OFF</to>
+								<power>30</power>
+								<time>30</time>
+							</transition>
+						</powerState>
+						<powerState>
+							<name>OFF</name>
+							<power>0</power>
+							<transition>
+								<to>ON</to>
+								<power>40</power>
+								<time>60</time>
+							</transition>
+						</powerState>
+					</powerStates>
+					<parameter name="pState">
+						<property name="name">
+							<value>P0</value>
+						</property>	
+						<property name="frequency">
+							<value>3000</value>
+						</property>		
+						<property name="voltage">
+							<value>1.3</value>
+						</property>
+						<property name="power">
+							<value>14</value>
+						</property>						
+					</parameter>
+					<parameter name="pState">
+						<property name="name">
+							<value>P1</value>
+						</property>	
+						<property name="frequency">
+							<value>2660</value>
+						</property>		
+						<property name="voltage">
+							<value>1.2</value>
+						</property>
+						<property name="power">
+							<value>12</value>
+						</property>						
+					</parameter>
+					<parameter name="pState">
+						<property name="name">
+							<value>P2</value>
+						</property>	
+						<property name="frequency">
+							<value>2330</value>
+						</property>		
+						<property name="voltage">
+							<value>1.1</value>
+						</property>
+						<property name="power">
+							<value>10</value>
+						</property>						
+					</parameter>
+					<parameter name="pState">
+						<property name="name">
+							<value>P3</value>
+						</property>	
+						<property name="frequency">
+							<value>2000</value>
+						</property>		
+						<property name="voltage">
+							<value>1.0</value>
+						</property>
+						<property name="power">
+							<value>8</value>
+						</property>						
+					</parameter>							
+				</powerProfile>
+			</profile>
 		</computingResourceTemplate>
 		<computingResourceTemplate class="Processor" id="modelProcessorB">
@@ -100,52 +132,84 @@
 				<name>CPUEnergyEstimationPlugin</name>
 			</energyEstimationPlugin>
-			<powerProfile>
-				<powerStates>
-					<powerState>
-						<name>ON</name>
-						<power>20</power>
-						<transition>
-							<to>OFF</to>
-							<power>30</power>
-							<time>30</time>
-						</transition>
-					</powerState>
-					<powerState>
-						<name>OFF</name>
-						<power>0</power>
-						<transition>
-							<to>ON</to>
-							<power>40</power>
-							<time>60</time>
-						</transition>
-					</powerState>
-				</powerStates>
-				<pStates>
-					<pState>
-						<name>P0</name>
-						<frequency>2200</frequency>
-						<voltage>1.3</voltage>
-						<power>20</power>
-					</pState>
-					<pState>
-						<name>P1</name>
-						<frequency>2000</frequency>
-						<voltage>1.2</voltage>
-						<power>17</power>
-					</pState>
-					<pState>
-						<name>P2</name>
-						<frequency>1800</frequency>
-						<voltage>1.1</voltage>
-						<power>16</power>
-					</pState>
-					<pState>
-						<name>P3</name>
-						<frequency>1000</frequency>
-						<voltage>1.0</voltage>
-						<power>10</power>
-					</pState>
-				</pStates>
-			</powerProfile>
+			<profile>
+				<powerProfile>
+					<powerStates>
+						<powerState>
+							<name>ON</name>
+							<power>20</power>
+							<transition>
+								<to>OFF</to>
+								<power>30</power>
+								<time>30</time>
+							</transition>
+						</powerState>
+						<powerState>
+							<name>OFF</name>
+							<power>0</power>
+							<transition>
+								<to>ON</to>
+								<power>40</power>
+								<time>60</time>
+							</transition>
+						</powerState>
+					</powerStates>
+					<parameter name="pState">
+						<property name="name">
+							<value>P0</value>
+						</property>	
+						<property name="frequency">
+							<value>2200</value>
+						</property>		
+						<property name="voltage">
+							<value>1.3</value>
+						</property>
+						<property name="power">
+							<value>20</value>
+						</property>						
+					</parameter>
+					<parameter name="pState">
+						<property name="name">
+							<value>P1</value>
+						</property>	
+						<property name="frequency">
+							<value>2000</value>
+						</property>		
+						<property name="voltage">
+							<value>1.2</value>
+						</property>
+						<property name="power">
+							<value>17</value>
+						</property>						
+					</parameter>
+					<parameter name="pState">
+						<property name="name">
+							<value>P2</value>
+						</property>	
+						<property name="frequency">
+							<value>1800</value>
+						</property>		
+						<property name="voltage">
+							<value>1.1</value>
+						</property>
+						<property name="power">
+							<value>16</value>
+						</property>						
+					</parameter>
+					<parameter name="pState">
+						<property name="name">
+							<value>P3</value>
+						</property>	
+						<property name="frequency">
+							<value>1000</value>
+						</property>		
+						<property name="voltage">
+							<value>1.0</value>
+						</property>
+						<property name="power">
+							<value>10</value>
+						</property>						
+					</parameter>
+				</powerProfile>
+			</profile>
 		</computingResourceTemplate>
 	</templates>
Index: xssim/trunk/src/test/rewolucja/schemas/example/example5.xml
===================================================================
--- xssim/trunk/src/test/rewolucja/schemas/example/example5.xml	(revision 316)
+++ xssim/trunk/src/test/rewolucja/schemas/example/example5.xml	(revision 318)
@@ -11,30 +11,46 @@
 						<name>CPUEnergyEstimationPlugin</name>
 					</energyEstimationPlugin>
-					<powerProfile>
-						<powerStates>
-							<powerState>
-								<name>ON</name>
-								<power>20</power>
-							</powerState>
-							<powerState>
-								<name>OFF</name>
-								<power>0</power>
-							</powerState>
-						</powerStates>
-						<pStates>
-							<pState>
-								<name>P0</name>
-								<frequency>3000</frequency>
-								<voltage>1.3</voltage>
-								<power>35</power>
-							</pState>
-							<pState>
-								<name>P1</name>
-								<frequency>2666</frequency>
-								<voltage>1.1</voltage>
-								<power>30</power>
-							</pState>
-						</pStates>
-					</powerProfile>
+					<profile>
+						<powerProfile>
+							<powerStates>
+								<powerState>
+									<name>ON</name>
+									<power>20</power>
+								</powerState>
+								<powerState>
+									<name>OFF</name>
+									<power>0</power>
+								</powerState>
+							</powerStates>
+							<parameter name="pState">
+								<property name="name">
+									<value>P0</value>
+								</property>	
+								<property name="frequency">
+									<value>3000</value>
+								</property>		
+								<property name="voltage">
+									<value>1.3</value>
+								</property>
+								<property name="power">
+									<value>35</value>
+								</property>						
+							</parameter>
+							<parameter name="pState">
+								<property name="name">
+									<value>P1</value>
+								</property>	
+								<property name="frequency">
+									<value>2666</value>
+								</property>		
+								<property name="voltage">
+									<value>1.1</value>
+								</property>
+								<property name="power">
+									<value>30</value>
+								</property>						
+							</parameter>
+						</powerProfile>
+					</profile>
 				</computingResource>
 				<energyEstimationPlugin>
@@ -46,8 +62,8 @@
 			<schedulingPlugin>
 				<name>FCFSLocalSchedulingPlugin</name>
-			</schedulingPlugin>		
-				<managedComputingResource include="false">
-					<resourceId>compRes1</resourceId>
-				</managedComputingResource>
+			</schedulingPlugin>	
+			<managedComputingResource include="false">
+				<resourceId>compRes1</resourceId>
+			</managedComputingResource>
 		</scheduler>	
 	</resources>